diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/select.c tin-2.6.5/src/select.c
--- tin-2.6.4/src/select.c	2024-12-11 16:43:15.000000000 +0100
+++ tin-2.6.5/src/select.c	2025-12-23 03:44:49.899727710 +0100
@@ -3,10 +3,10 @@
  *  Module    : select.c
  *  Author    : I. Lea & R. Skrenta
  *  Created   : 1991-04-01
- *  Updated   : 2024-11-25
+ *  Updated   : 2025-11-26
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -66,11 +66,12 @@ static void select_done(void);
 _Noreturn static void select_quit(void);
 static void select_read_group(void);
 static void sort_active_file(void);
-static void subscribe_pattern(const char *prompt, const char *message, const char *result, t_bool state);
+static void subscribe_pattern(t_bool state);
 static void sync_active_file(void);
 static void yank_active_file(void);
 #ifdef NNTP_ABLE
 	static char *lookup_msgid(const char *msgid);
+	static char *nntp_list_newsgroups_grp(const char *group);
 	static struct t_group *get_group_from_list(char *newsgroups);
 #endif /* NNTP_ABLE */
 
@@ -324,6 +325,74 @@ selection_page(
 				show_selection_page();
 				break;
 
+			case MARK_ANCIENT_ART_READ:
+				if (selmenu.max && !CURR_GROUP.bogus) {
+					char *p;
+					char tmp[LEN];
+					int days;
+					unsigned int cnt = 0;
+					time_t past = -1;
+
+					clear_message();
+					if (prompt_default_string(_(txt_group_mark_ancient_art_read), tmp, sizeof(tmp), NULL, HIST_OTHER)) {
+#ifdef HAVE_STRPTIME
+						struct tm tm;
+#endif /* HAVE_STRPTIME */
+
+						str_trim(tmp);
+#ifdef HAVE_STRPTIME
+						memset(&tm, 0, sizeof(tm));
+						if (strptime(tmp, *CURR_GROUP.attribute->date_format, &tm))
+							past = mktime(&tm);
+#endif /* HAVE_STRPTIME */
+						if (past < 0 && (p = strchr(tmp, ' '))) { /* could be a date string, try to parse */
+							if ((past = parsedate(tmp, (struct _TIMEINFO *) 0)) < 0 && isalpha((unsigned char) tmp[0]))  /* failed, try again with first "word" skipped */
+								past = parsedate(p + 1, (struct _TIMEINFO *) 0);
+						}
+
+						if (past < 0) { /* not a valid date string, then take the leading digits as days */
+							p = tmp;
+							if (*p == '-' || *p == '+') /* ignore one leading sign if present */
+								p++;
+							if (isdigit((unsigned char) *p)) {
+								if ((days = strtol(p, NULL, 10)) > 0) {
+									if (days <= (time((time_t *) 0) / DAY))
+										past = (time((time_t *) 0) - (days * DAY));
+								} else
+									past = -2;
+							}
+						}
+
+						if (past >= time((time_t *) 0)) /* also avoid "catchup" with past == time(0) */
+							past = -2;
+
+						switch (past) {
+							case -2:
+								info_message(_(txt_error_date_future), tmp);
+								break;
+
+							case -1:
+								info_message(_(txt_error_date_unparsable), tmp);
+								break;
+
+							default:
+								if (index_group(&CURR_GROUP, FALSE)) {
+									for_each_art(i) {
+										if (arts[i].status > ART_READ && arts[i].date < past) {
+											art_mark(&CURR_GROUP, &arts[i], ART_READ);
+											++cnt;
+										}
+									}
+								}
+								if (cnt)
+									show_selection_page();
+								info_message(P_(txt_group_ancient_arts_marked_read_sp[0], txt_group_ancient_arts_marked_read_sp[1], cnt), cnt);
+								break;
+						}
+					}
+				}
+				break;
+
 #ifdef NNTP_ABLE
 			case GLOBAL_LOOKUP_MESSAGEID:
 				switch (show_article_by_msgid(NULL)) {
@@ -368,7 +437,8 @@ selection_page(
 
 			case GLOBAL_TOGGLE_INFO_LAST_LINE:	/* display group description */
 				tinrc.info_in_last_line = bool_not(tinrc.info_in_last_line);
-				show_selection_page();
+				clear_message();
+				draw_group_arrow();
 				break;
 
 			case SELECT_MOVE_GROUP:			/* reposition group within group list */
@@ -434,7 +504,7 @@ selection_page(
 				 * as we effectively do a yank out on each change, set yanked_out accordingly
 				 */
 				yanked_out = TRUE;
-				wait_message(0, _(txt_reading_groups), (tinrc.show_only_unread_groups) ? _(txt_unread) : _(txt_all));
+				wait_message(0, (tinrc.show_only_unread_groups) ? _(txt_reading_unread_groups) : _(txt_reading_all_groups));
 
 				toggle_my_groups(NULL);
 				show_selection_page();
@@ -470,7 +540,7 @@ selection_page(
 					info_message(_(txt_info_no_write));
 					break;
 				}
-				subscribe_pattern(_(txt_subscribe_pattern), _(txt_subscribing), _(txt_subscribed_num_groups), TRUE);
+				subscribe_pattern(TRUE);
 				break;
 
 			case SELECT_UNSUBSCRIBE:		/* unsubscribe to current group */
@@ -483,6 +553,7 @@ selection_page(
 					break;
 				}
 				if (CURR_GROUP.subscribed) {
+					/* TODO: make marks user configurable like art_makred_* */
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 					mark_screen(selmenu.curr, flags_offset, CURR_GROUP.newgroup ? (const wchar_t *) L"N" : (const wchar_t *) L"u");
 #else
@@ -509,8 +580,7 @@ selection_page(
 					info_message(_(txt_info_no_write));
 					break;
 				}
-				subscribe_pattern(_(txt_unsubscribe_pattern),
-								_(txt_unsubscribing), _(txt_unsubscribed_num_groups), FALSE);
+				subscribe_pattern(FALSE);
 				break;
 
 			case GLOBAL_VERSION:			/* show tin version */
@@ -523,39 +593,79 @@ selection_page(
 						info_message(_(txt_cannot_post));
 						break;
 					}
+					/* TODO: plural-forms? */
 					snprintf(buf, sizeof(buf), _(txt_post_newsgroups), BlankIfNull(tinrc.default_post_newsgroups));
 					if (!prompt_string_ptr_default(buf, &tinrc.default_post_newsgroups, _(txt_no_newsgroups), HIST_POST_NEWSGROUPS))
 						break;
+
 					str_trim(tinrc.default_post_newsgroups);
 					if (!*tinrc.default_post_newsgroups)
 						break;
-					if (group_find(tinrc.default_post_newsgroups, FALSE) == NULL) {
-						error_message(2, _(txt_not_in_active_file), tinrc.default_post_newsgroups);
-						break;
-					} else {
-						STRCPY(buf, tinrc.default_post_newsgroups);
+					else {
+						char *cg, *ng, *ngcpy, *new_list = NULL, *reject = NULL;
+
+						n = 0;
+						*buf = '\0';
+						ng = ngcpy = my_strdup(tinrc.default_post_newsgroups);
+						while ((cg = strtok(ng, ", \t")) != NULL) {
+							if (group_find(cg, FALSE) == NULL) {
+								reject = append_to_string(reject, cg);
+								reject = append_to_string(reject, ",");
+								++n;
+							} else {
+								if (!*buf)
+									strcpy(buf, cg);
+								new_list = append_to_string(new_list, cg);
+								new_list = append_to_string(new_list, ",");
+							}
+							ng = NULL;
+						}
+						free(ngcpy);
+						if (reject && *reject) {
+							i = strlen(reject);
+							if (*(reject + i - 1) == ',')
+								*(reject + i - 1) = '\0';
+							/* TODO: improve error/warningf (-n) message */
+							error_message((n & 0x07), _(txt_not_in_active_file), reject);
+							free(reject);
+						}
+						if (new_list && *new_list) {
+							if (n) { /* without errors no need to use new_list */
+								i = strlen(new_list);
+								if (*(new_list + i - 1) == ',')
+									*(new_list + i - 1) = '\0';
+								strcpy(tinrc.default_post_newsgroups, new_list);
+							}
+							free(new_list);
+						}
+						if (!*buf) {
+							error_message(3, "%s%s", P_(txt_error_no_valid_newsgroup_sp[0], txt_error_no_valid_newsgroup_sp[1], n), list_active ? "" : _(txt_error_retry_without_n));
+							break;
+						}
+					}
 #if 1 /* TODO: fix the rest of the code so we don't need this anymore */
-						/*
-						 * this is a gross hack to avoid a crash in the
-						 * CHARSET_CONVERSION case in new_part()
-						 * which currently relies on CURR_GROUP
-						 */
-						selmenu.curr = my_group_add(buf, FALSE);
-						/*
-						 * and the next hack to avoid a grabbled selection
-						 * screen after the posting
-						 */
-						toggle_my_groups(NULL);
-						toggle_my_groups(NULL);
+					/*
+					 * this is a gross hack to avoid a crash in the
+					 * CHARSET_CONVERSION case in new_part()
+					 * which currently relies on CURR_GROUP
+					 */
+					selmenu.curr = my_group_add(buf, FALSE);
+					*buf = '\0';
+					/*
+					 * and the next hack to avoid a grabbled selection
+					 * screen after the posting
+					 */
+					toggle_my_groups(NULL);
+					toggle_my_groups(NULL);
 #endif /* 1 */
-					}
 				} else
 					STRCPY(buf, CURR_GROUP.name);
+
 				if (!can_post && !CURR_GROUP.bogus && !(CURR_GROUP.attribute->mailing_list && *CURR_GROUP.attribute->mailing_list)) {
 					info_message(_(txt_cannot_post));
 					break;
 				}
-				if (post_article(buf))
+				if (post_article(*buf ? buf : tinrc.default_post_newsgroups))
 					show_selection_page();
 				break;
 
@@ -679,10 +789,10 @@ show_selection_page(
 	if (recalc) {
 		if (sel_fmt.len_grpname_max && !sel_fmt.len_grpname) {
 			/*
-			* calculate max length of groupname field
-			* if yanked in (yanked_out == FALSE) check all groups in active file
-			* otherwise just subscribed to groups
-			*/
+			 * calculate max length of groupname field if yanked
+			 * in (yanked_out == FALSE) check all groups in active
+			 * file otherwise just subscribed to groups
+			 */
 			if (yanked_out) {
 				for (i = 0; i < selmenu.max; i++) {
 					if ((len = (size_t) strwidth(active[my_group[i]].name)) > sel_fmt.len_grpname)
@@ -746,7 +856,7 @@ build_gline(
 	wchar_t *active_name, *active_name2 = NULL, *active_desc, *active_desc2;
 #else
 	char *active_name, *active_name2;
-	size_t fill, len_start;
+	int fill, len_start;
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
 #ifdef USE_CURSES
@@ -826,7 +936,7 @@ build_gline(
 				 * . Newgroups are 'N'
 				 * . Unsubscribed groups are 'u'
 				 *
-				 * TODO: make flags configurable via tinrc?
+				 * TODO: make flags configurable via tinrc
 				 */
 				if (active[n].bogus)					/* Group is not in active list */
 					subs = 'D';
@@ -899,10 +1009,10 @@ build_gline(
 					*buf = '\0';
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 				} else if (active[my_group[i]].newsrc.num_unread) {
-					int getart_limit;
+					struct t_attribute *attrib = active[my_group[i]].attribute;
+					int getart_limit = (attrib && getart_limit_set_from_scope(&active[my_group[i]])) ? attrib->getart_limit : (cmdline.args & CMDLINE_GETART_LIMIT) ? cmdline.getart_limit : tinrc.getart_limit;
 					t_artnum num_unread;
 
-					getart_limit = (cmdline.args & CMDLINE_GETART_LIMIT) ? cmdline.getart_limit : tinrc.getart_limit;
 					num_unread = active[my_group[i]].newsrc.num_unread;
 					if (getart_limit > 0 && getart_limit < num_unread)
 						num_unread = getart_limit;
@@ -987,7 +1097,7 @@ yank_active_file(
 		selmenu.curr = save_restore_curr_group(FALSE);	/* Restore previous group position */
 		yanked_out = bool_not(yanked_out);
 		show_selection_page();
-		info_message(_(txt_yanked_groups), selmenu.max - prevmax, PLURAL(selmenu.max - prevmax, txt_group));
+		info_message(P_(txt_yanked_group_sp[0], txt_yanked_group_sp[1], selmenu.max - prevmax), selmenu.max - prevmax);
 	} else {							/* Yank out */
 		toggle_my_groups(NULL);
 		HpGlitch(erase_arrow());
@@ -1091,8 +1201,79 @@ choose_new_group(
 		return -1;
 
 	clear_message();
+	idx = my_group_add(tinrc.default_goto_group, TRUE);
+
+	if (idx == -1 && !list_active) {
+		struct t_group *ptr;
+		t_artnum count = T_ARTNUM_CONST(-1), min = T_ARTNUM_CONST(1), max = T_ARTNUM_CONST(0);
+
+		if (!group_get_art_info(spooldir, tinrc.default_goto_group, GROUP_TYPE_NEWS, &count, &max, &min)) {
+			if ((idx = my_group_add(tinrc.default_goto_group, TRUE)) < 0) {
+				if ((ptr = group_add(tinrc.default_goto_group)) != NULL) {
+					char *desc = NULL;
+					char *moderated = my_malloc(NNTP_STRLEN);
+
+					moderated[0] = 'y';
+					moderated[1] = '\0';
+#		ifdef NNTP_ABLE
+					if (read_news_via_nntp && nntp_caps.type == CAPABILITIES) {
+						if (nntp_caps.list_active) {
+							if (nntp_list_active_grp(tinrc.default_goto_group, moderated) && nntp_caps.list_newsgroups)
+								desc = nntp_list_newsgroups_grp(tinrc.default_goto_group);
+						}
+					}
+#		endif /* NNTP_ABLE */
+#		ifndef NNTP_ONLY
+					if (!read_news_via_nntp && !list_active) {
+						FILE *fp;
+						char *rp;
+						size_t gl = strlen(tinrc.default_goto_group);
+						t_artnum ac_min = T_ARTNUM_CONST(1), ac_max = T_ARTNUM_CONST(0);
+
+						if ((fp = tin_fopen(news_active_file, "r")) != NULL) {
+							while ((rp = tin_fgets(fp, FALSE)) != NULL) {
+								if (strncmp(tinrc.default_goto_group, rp, gl))
+									continue;
+
+								if (*(rp + gl) != ' ')
+									continue;
+
+								if (parse_active_line(rp, &ac_max, &ac_min, moderated))
+									break;
+							}
+							fclose(fp);
+						}
 
-	if ((idx = my_group_add(tinrc.default_goto_group, TRUE)) == -1)
+						if ((fp = tin_fopen(newsgroups_file, "r")) != NULL) {
+							while ((rp = tin_fgets(fp, FALSE)) != NULL) {
+								if (strncmp(tinrc.default_goto_group, rp, gl))
+									continue;
+
+								if (!isblank(*(rp + gl)))
+									continue;
+
+								if (*(rp + gl + 1))
+									desc = my_strdup(rp + gl + 1);
+								break;
+							}
+							fclose(fp);
+						}
+					}
+#		endif /* NNTP_ONLY */
+
+					active_add(ptr, count, max, min, moderated);
+					if ((idx = my_group_add(tinrc.default_goto_group, TRUE)) != -1) {
+						assign_attributes_to_groups();
+						if (desc)
+							active[my_group[idx]].description = convert_to_printable(desc, FALSE);
+					}
+					free(moderated);
+				}
+			}
+		}
+	}
+
+	if (idx == -1)
 		info_message(_(txt_not_in_active_file), tinrc.default_goto_group);
 
 	return idx;
@@ -1406,7 +1587,7 @@ toggle_my_groups(
 	if ((fp = tin_fopen(newsrc, "r")) == NULL)
 		return;
 
-	while (fgets(buf, (int) sizeof(buf), fp) != NULL) {
+	while (fgets(buf, sizeof(buf), fp) != NULL) {
 		if ((ptr = strchr(buf, SUBSCRIBED)) != NULL) {
 			*ptr = '\0';
 
@@ -1432,12 +1613,11 @@ toggle_my_groups(
  */
 static void
 subscribe_pattern(
-	const char *prompt,
-	const char *message,
-	const char *result,
 	t_bool state)
 {
 	char buf[LEN];
+	const char *prompt;
+	const char *message;
 	int i, subscribe_num = 0;
 	size_t groups_size = 100;
 	struct t_group **groups;
@@ -1445,6 +1625,13 @@ subscribe_pattern(
 	if (!num_active || no_write)
 		return;
 
+	if (state) {
+		prompt = _(txt_subscribe_pattern);
+		message = _(txt_subscribing);
+	} else {
+		prompt = _(txt_unsubscribe_pattern);
+		message = _(txt_unsubscribing);
+	}
 	if (!prompt_string(prompt, buf, HIST_OTHER) || !*buf) {
 		clear_message();
 		return;
@@ -1452,12 +1639,12 @@ subscribe_pattern(
 
 	groups = my_malloc(groups_size * sizeof(struct t_group *));
 
-	wait_message(0, "%s", message);
+	wait_message(0, message);
 
 	for_each_group(i) {
+		spin_cursor();
 		if (match_group_list(active[i].name, buf)) {
 			if (active[i].subscribed != (state != FALSE)) {
-				spin_cursor();
 				if ((size_t) subscribe_num == groups_size) {
 					groups_size <<= 1;
 					groups = my_realloc(groups, groups_size * sizeof(struct t_group *));
@@ -1473,14 +1660,196 @@ subscribe_pattern(
 		}
 	}
 
-	bulk_subscribe(groups, subscribe_num, SUB_CHAR(state), TRUE);
+	if (!list_active) {
+		char *line;
+		char *s, *name;
+		char moderated[PATH_LEN];
+		int idx;
+		struct t_group *ptr;
+		t_artnum count = T_ARTNUM_CONST(-1), min = T_ARTNUM_CONST(1), max = T_ARTNUM_CONST(0);
+
+#ifdef NNTP_ABLE
+		if (read_news_via_nntp) {
+			if (nntp_caps.type == CAPABILITIES && nntp_caps.list_active) {	/* "LIST ACTIVE pattern" */
+				char cmd[NNTP_STRLEN];
+
+				snprintf(cmd, sizeof(cmd), "LIST ACTIVE %.*s", (int) (NNTP_STRLEN - strlen("LIST ACTIVE ") - 1), buf);
+				switch (new_nntp_command(cmd, OK_GROUPS, NULL, 0)) {
+					case OK_GROUPS:
+						while ((line = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
+							spin_cursor();
+#	ifdef DEBUG
+							if (debug & DEBUG_NNTP)
+								debug_print_file("NNTP", "<<<%s%s", logtime(), line);
+#	endif /* DEBUG */
+							if (parse_active_line(line, &max, &min, moderated)) { /* parse_active_line() modifies line */
+								if (my_group_add(line, FALSE) < 0) {
+									if ((ptr = group_add(line)) != NULL) {
+										if ((size_t) subscribe_num == groups_size) {
+											groups_size <<= 1;
+											groups = my_realloc(groups, groups_size * sizeof(struct t_group *));
+										}
+										active_add(ptr, count, max, min, moderated);
+										groups[subscribe_num] = &active[i];
+										my_group_add(line, FALSE);
+										++i;
+										++subscribe_num;
+									}
+								}
+							}
+						}
+						break;
+
+					default:
+						break;
+				}
+
+				if (subscribe_num) {
+					if (nntp_caps.list_newsgroups) { /* "LIST NEWSGROUPS list" */
+						t_bool conv_needed;
+
+						snprintf(cmd, sizeof(cmd), "LIST NEWSGROUPS %.*s", (int) (NNTP_STRLEN - strlen("LIST NEWSGROUPS ") - 1), buf);
+						switch (new_nntp_command(cmd, OK_GROUPS, NULL, 0)) {
+							case OK_GROUPS:
+								while ((line = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
+									spin_cursor();
+#	ifdef DEBUG
+									if (debug & DEBUG_NNTP)
+										debug_print_file("NNTP", "<<<%s%s", logtime(), line);
+#	endif /* DEBUG */
+									if ((s = strpbrk(line, " \t")) == NULL)
+										continue;
+
+									*s++ = '\0';
+									if (!match_group_list(line, buf))
+										continue;
+
+									if ((idx = find_group_index(line, FALSE)) != -1) {
+										conv_needed = FALSE;
+										name = my_strdup(s);
+										while (*s) {
+											if (*s == '\t')
+												*s = ' ';
+											else {
+												if (!conv_needed && (*s < 0x20 || !isascii((unsigned char) *s)))
+													conv_needed = TRUE;
+											}
+											++s;
+										}
+										FreeIfNeeded(active[idx].description);
+										if (conv_needed)
+											csguess_convert_str(&name, "UTF-8");
+										str_trim(name);
+										if (*name)
+											active[idx].description = convert_to_printable(name, FALSE);
+										else
+											free(name);
+									}
+								}
+								break;
+
+							default:
+								break;
+						}
+					}
+
+					{	/* mark unread (does "GROUP"-cmd. so it can't be done above) */
+						int j = subscribe_num;
+						int k = i;
+
+						while (j--)
+							grp_mark_unread(&active[--k]);
+					}
+					assign_attributes_to_groups();
+				}
+			} else {
+				/*
+				 * 'S' with -n on pre RFC3977 server doesn't work, it may
+				 * result in too much data (full active file), we could
+				 * filter that on our own (match_group_list()) but that
+				 * would be not a big win over just leaving out -n.
+				 */
+				info_message(_(txt_no_match));
+				free(groups);
+				return;
+			}
+		}
+#	ifndef NNTP_ONLY
+		else
+#	endif /* !NNTP_ONLY */
+#endif /* NNTP_ABLE */
+
+#ifndef NNTP_ONLY
+		{ /* local spool */
+			FILE *fp;
+
+			if ((fp = tin_fopen(news_active_file, "r")) != NULL) {
+				while ((line = tin_fgets(fp, FALSE)) != NULL) {
+					spin_cursor();
+					if ((s = strchr(line, ' ')) == NULL)
+						continue;
+
+					name = my_strndup(line, s - line);
+					if (match_group_list(name, buf)) {
+						if (!group_get_art_info(spooldir, name, GROUP_TYPE_NEWS, &count, &max, &min)) {
+							if (my_group_add(name, FALSE) < 0) {
+								if ((ptr = group_add(name)) != NULL) {
+									if (parse_active_line(line, &max, &min, moderated)) {
+										if ((size_t) subscribe_num == groups_size) {
+											groups_size <<= 1;
+											groups = my_realloc(groups, groups_size * sizeof(struct t_group *));
+										}
+										active_add(ptr, count, max, min, moderated);
+										groups[subscribe_num] = &active[i];
+										my_group_add(name, FALSE);
+										grp_mark_unread(&active[i]);
+										++i;
+										++subscribe_num;
+									}
+								}
+							}
+						}
+					}
+					free(name);
+				}
+				fclose(fp);
+				assign_attributes_to_groups();
+			}
+			if (subscribe_num) {
+				if ((fp = tin_fopen(newsgroups_file, "r")) != NULL) {
+					while ((line = tin_fgets(fp, FALSE)) != NULL) {
+						spin_cursor();
+						if ((s = strpbrk(line, " \t")) == NULL)
+							continue;
+
+						*s++ = '\0';
+						if (!match_group_list(line, buf))
+							continue;
+
+						if ((idx = find_group_index(line, FALSE)) != -1) {
+							name = my_strdup(s);
+							FreeIfNeeded(active[idx].description);
+							active[idx].description = convert_to_printable(name, FALSE);
+						}
+					}
+					fclose(fp);
+				}
+			}
+		}
+#endif /* !NNTP_ONLY */
+	}
+	/* avoid GROUP cmds via get_subscribe_info(group_get_art_info()) */
+	bulk_subscribe(groups, subscribe_num, SUB_CHAR(state), subscribe_num && read_news_via_nntp && nntp_caps.type == CAPABILITIES && nntp_caps.list_active ? FALSE : TRUE);
 
 	free(groups);
 
 	if (subscribe_num) {
 		toggle_my_groups(NULL);
 		show_selection_page();
-		info_message(result, subscribe_num);
+		info_message(state ?
+			P_(txt_subscribed_num_group_sp[0], txt_subscribed_num_group_sp[1], subscribe_num) :
+			P_(txt_unsubscribed_num_group_sp[0], txt_unsubscribed_num_group_sp[1], subscribe_num),
+			subscribe_num);
 	} else
 		info_message(_(txt_no_match));
 }
@@ -1558,8 +1927,50 @@ lookup_msgid(
 			char buf[NNTP_STRLEN];
 			int ret;
 
-			if (nntp_caps.hdr_cmd) {
-				snprintf(buf, sizeof(buf), "%s Newsgroups %s", nntp_caps.hdr_cmd, msgid);
+			if (nntp_caps.hdr_cmd && *nntp_caps.hdr_cmd) {
+				char *s, *e;
+				int which_hdr = 0;
+				t_bool skip;
+
+				/*
+				 * check which hds are available via HDR msg-id
+				 * and if available prefer "HDR Xref ID" as that will
+				 * only return the local available groups and in
+				 * case of control messages the pseudo group used.
+				 */
+				if (nntp_caps.type == CAPABILITIES && !*nntp_caps.headers_id) {
+					switch (new_nntp_command("LIST HEADERS MSGID", 215, NULL, 0)) {
+						case 215:
+							while ((ptr = tin_fgets(FAKE_NNTP_FP, FALSE)) != NULL) {
+#		ifdef DEBUG
+								if (debug & DEBUG_NNTP)
+									debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
+#		endif /* DEBUG */
+								nntp_caps.headers_id = append_to_string(nntp_caps.headers_id, ptr);
+								nntp_caps.headers_id = append_to_string(nntp_caps.headers_id, "\n");
+							}
+							break;
+
+						default:
+							break;
+					}
+				}
+
+				if (nntp_caps.headers_id && (ptr = strtok(nntp_caps.headers_id, "\n")) != NULL) {
+					do { /* TODO: avoid magic numbers */
+						if ((*ptr == ':' && *(ptr + 1) == '\0')) {
+							which_hdr = 3;
+							break;
+						}
+						if (!strncasecmp(ptr, "Xref", 4))
+							which_hdr |= 1;
+						if (!strncasecmp(ptr, "Newsgroups", 10))
+							which_hdr |= 2;
+					} while (*ptr && (ptr = strtok(NULL, "\n")) != NULL);
+				} else
+					which_hdr = 1; /* fallback, try [X]HDR Xref */
+
+				snprintf(buf, sizeof(buf), "%s %s %s", nntp_caps.hdr_cmd, (which_hdr & 1) ? "Xref" : "Newsgroups", msgid);
 				ret = new_nntp_command(buf, (nntp_caps.type == CAPABILITIES) ? OK_HDR : OK_HEAD, NULL, 0);
 
 				switch (ret) {
@@ -1571,30 +1982,52 @@ lookup_msgid(
 							if (debug & DEBUG_NNTP)
 								debug_print_file("NNTP", "<<<%s%s", logtime(), ptr);
 #		endif /* DEBUG */
-
-							if (ret == OK_HEAD) { /* RFC 2980 ("%s %s", id, grp) */
-								if (!strncmp(ptr, msgid, strlen(msgid))) { /* INN, MPNews, Leafnode, Cnews nntpd */
-									r = ptr + strlen(msgid) + 1;
-								} else { /* DNEWS ("%d %s", num, grp) */
-									r = ptr;
-									while (*r && *r != ' ' && *r != '\t')
-										++r;
-									while (*r && (*r == ' ' || *r == '\t'))
-										++r;
+							if (ret == OK_HEAD || (ret == OK_HDR && (which_hdr & 1))) {
+								s = ptr;
+								if (*s == '0' && *(s + 1) == ' ') /* RFC 3977, "0 site.name gro.up:num gr.oup:num ..." */
+									s += 2;
+								else { /* RFC 2980 "<ID> site.name gro.up:num gr.oup:num ..." */
+									if (*ptr == '<') {
+										while (*s && !isspace((unsigned char) *s))
+											++s;
+										while (*s && isspace((unsigned char) *s))
+											++s;
+									}
 								}
-							}
-
-							if (ret == OK_HDR) { /* RFC 3977 ("0 %s", grp) */
+								/* skip site name */
+								while (*s && !isspace((unsigned char) *s))
+									++s;
+								while (*s && isspace((unsigned char) *s))
+									++s;
+
+								if (*s) { /* reformat, Newsgroups-style - ID should be available in the first group but ... */
+									skip = FALSE;
+									x = e = my_malloc(strlen(s) + 1);
+									while (*s) {
+										if (*s == ':') {
+											*e++ = ',';
+											skip = TRUE;
+										}
+										if (!skip && *s != ':' && !isspace((unsigned char) *s))
+											*e++ = *s;
+										if (isspace((unsigned char) *s))
+											skip = FALSE;
+										++s;
+									}
+									if (e == x) {
+										FreeAndNull(x);
+									} else
+											*--e = '\0';
+								}
+							} else { /* HDR Newsgroups */
 								if (*ptr == '0' && (*(ptr + 1) == ' ' || *(ptr + 1) == '\t'))
 									r = ptr + 2;
-							}
-
-							if (r) {
-								FreeIfNeeded(x);	/* only required on bogus multi responses, just to be safe */
-								x = my_strdup(r);
+								if (r) {
+									FreeIfNeeded(x);	/* only required on bogus multi responses, just to be safe */
+									x = my_strdup(r);
+								}
 							}
 						}
-
 						if (x)
 							return x;
 
@@ -1611,9 +2044,16 @@ lookup_msgid(
 						break;
 
 					case ERR_NOART:
+					case 530: /* colobus 3.0 */
 						info_message(_(txt_art_unavailable));
 						return NULL;
 
+					case ERR_COMMAND: /* Usenet.Farm announces HDR but ... */
+						nntp_caps.hdr_cmd = NULL;
+						nntp_caps.hdr = FALSE;
+						nntp_caps.xpat = TRUE;
+						break;
+
 					default:
 						if (!nntp_caps.xpat) { /* try only once */
 							info_message(_(txt_lookup_func_not_available));
@@ -1689,9 +2129,7 @@ show_article_by_msgid(
 	char *newsgroups = NULL;
 	char *ngcpy, *cg, *ng;
 	int i, ret = 0;
-	struct t_article *art;
-	struct t_group *group = NULL;
-	struct t_group *tmp_group = NULL;
+	struct t_group *saved_curr_group = NULL;
 	struct t_msgid *msgid = NULL;
 	t_bool tmp_cache_overview_files;
 	t_bool tmp_show_only_unread_arts;
@@ -1719,42 +2157,96 @@ show_article_by_msgid(
 	if (!newsgroups)
 		return LOOKUP_ART_UNAVAIL;
 
-	/* set selmenu.curr */
+	/* save original and set new selmenu.curr */
+	save_restore_curr_group(TRUE);
 	ng = ngcpy = my_strdup(newsgroups); /* take a copy for strtok */
 	while ((cg = strtok(ng, ",")) != NULL) {
 		if ((selmenu.curr = my_group_add(cg, FALSE)) != -1)
 			break;
+		else {
+			struct t_group *ptr;
+			t_artnum count = T_ARTNUM_CONST(-1), min = T_ARTNUM_CONST(1), max = T_ARTNUM_CONST(0);
+
+			if (!group_get_art_info(spooldir, cg, GROUP_TYPE_NEWS, &count, &max, &min)) {
+				if ((selmenu.curr = my_group_add(cg, FALSE)) < 0) {
+					if ((ptr = group_add(cg)) != NULL) {
+						char *desc = NULL;
+						char *moderated = my_malloc(NNTP_STRLEN);
+
+						moderated[0] = 'y';
+						moderated[1] = '\0';
+						if (nntp_caps.type == CAPABILITIES && nntp_caps.list_active) {
+							if (nntp_list_active_grp(cg, moderated) && nntp_caps.list_newsgroups)
+								desc = nntp_list_newsgroups_grp(cg);
+						}
+
+						active_add(ptr, count, max, min, moderated);
+						free(moderated);
+						if ((selmenu.curr = my_group_add(cg, FALSE)) != -1) {
+							assign_attributes_to_groups();
+							if (desc)
+								active[my_group[selmenu.curr]].description = convert_to_printable(desc, FALSE);
+							break;
+						}
+					}
+				} else
+					break;
+			}
+		}
 		ng = NULL;
 	}
 
-	if (selmenu.curr == -1 || !cg || (group = get_group_from_list(cg)) == NULL) {
+	if (curr_group)
+		saved_curr_group = curr_group;
+	if (selmenu.curr == -1 || !cg || (curr_group = get_group_from_list(cg)) == NULL) {
+		for (ng = newsgroups, i = 1; *ng; ng++) {
+			if (*ng == ',')
+				++i;
+		}
 		if (!cmdline.msgid)
-			info_message(strchr(newsgroups, ',') ? _(txt_lookup_show_groups) : _(txt_lookup_show_group), newsgroups);
+			info_message(P_(txt_lookup_show_group_sp[0], txt_lookup_show_group_sp[1], i), newsgroups);
 		else /* -L cmd. */
-			wait_message(2, strchr(newsgroups, ',') ? _(txt_lookup_show_groups) : _(txt_lookup_show_group), newsgroups);
+			wait_message(2, P_(txt_lookup_show_group_sp[0], txt_lookup_show_group_sp[1], i), newsgroups);
 		free(newsgroups);
 		free(ngcpy);
+		if (saved_curr_group)
+			curr_group = saved_curr_group;
 		return LOOKUP_FAILED;
 	}
 	free(ngcpy);
 
-	if (curr_group)
-		tmp_group = curr_group;
-	curr_group = group;
 	num_of_tagged_arts = 0;
 	range_active = FALSE;
 	this_resp = last_resp = -1;
-	tmp_cache_overview_files = tinrc.cache_overview_files;
-	tinrc.cache_overview_files = FALSE;
+	tmp_cache_overview_files = serverrc.cache_overview_files;
+	serverrc.cache_overview_files = FALSE;
 	tmp_show_only_unread_arts = curr_group->attribute->show_only_unread_arts;
 	curr_group->attribute->show_only_unread_arts = FALSE;
 
-	if (!index_group(group)) {
+	if (!index_group(curr_group, TRUE)) {
+		/*
+		 * can't see how this ever could leak, so why bother?
+		 * (next index_group() or tin_done() will take care
+		 * of the free()s and nothing else should modify arts[])
+		 * and if, why not also clear xref and mailbox.next?
+		 * (use free_art_array() then)
+		 */
+#if 0
+		struct t_article *art;
+
 		for_each_art(i) {
 			art = &arts[i];
-			FreeAndNull(art->refs);
 			FreeAndNull(art->msgid);
+			FreeAndNull(art->refs);
+			/* FreeAndNull(art->xref); */
+			/* free_mailbox_list(art->mailbox.next); */
 		}
+		/*
+		 * the obove is more or less free_art_array()
+		 * why not also do hash_reclaim() here?
+		 */
+#endif /* 0 */
+		selmenu.curr = save_restore_curr_group(FALSE);
 		tin_errno = 0;
 		ret = LOOKUP_FAILED;
 	}
@@ -1765,7 +2257,7 @@ show_article_by_msgid(
 		if (*idptr == '\0')
 			ret = LOOKUP_ART_UNAVAIL;
 
-		if ((msgid = find_msgid(idptr)) == NULL)
+		if (!ret && (msgid = find_msgid(idptr)) == NULL)
 			ret = LOOKUP_ART_UNAVAIL;
 
 		if (!ret && msgid->article == ART_UNAVAILABLE)
@@ -1775,35 +2267,16 @@ show_article_by_msgid(
 			ret = LOOKUP_NO_LAST;
 	}
 
-	if (!ret) {
-		switch (show_page(group, msgid->article, NULL)) {
-			case GRP_QUIT:
-				ret = LOOKUP_QUIT;
-				break;
-
-			default:
-				break;
-		}
-	}
+	if (!ret && show_page(curr_group, msgid->article, NULL) == GRP_QUIT)
+		ret = LOOKUP_QUIT;
 
 	free(newsgroups);
 	art_close(&pgart);
-	tinrc.cache_overview_files = tmp_cache_overview_files;
+	serverrc.cache_overview_files = tmp_cache_overview_files;
 	curr_group->attribute->show_only_unread_arts = CAST_BOOL(tmp_show_only_unread_arts);
-	if (tmp_group) {
-		curr_group = tmp_group;
-		if (!index_group(curr_group)) {
-			for_each_art(i) {
-				art = &arts[i];
-				FreeAndNull(art->refs);
-				FreeAndNull(art->msgid);
-			}
-			curr_group = NULL;
-			tin_errno = 0;
-			ret = LOOKUP_FAILED;
-		}
-	} else
-		curr_group = NULL;
+
+	if (saved_curr_group != curr_group)
+		curr_group = saved_curr_group;
 
 	this_resp = last_resp = -1;
 
